<style lang="scss">
  #index {
    .rate-limit {
      padding: 0 24px;
    }

    .profile-image {
      border-radius: 50%;
      height: 50px;
    }
  }

  .modal-button-wrapper {
    .q-input {
      padding: 8px 0;
    }

    .q-toggle {
      padding: 16px 0;
    }

    .button-container {
      display: flex;
      flex-direction: row;
      justify-content: space-between;
      width: 100%;
    }
  }
</style>

<template>
  <q-layout ref="layout" view="lHh Lpr fff" class="card-padding" id="index">
    <q-layout-header>
      <q-toolbar>
        <q-toolbar-title>Commit Log <sub><small><i>beta</i></small></sub></q-toolbar-title>

        <div v-if="totalRateLimit && remainingRateLimit" class="column items-center justify-center rate-limit">
          <strong>{{ totalRateLimit }} / {{ remainingRateLimit }}</strong>
          <small>Rate limit</small>
          <q-tooltip>
            The <i>rate limit</i> is applied by github, to increase it, log into your account with the button
            to the right
          </q-tooltip>
        </div>

        <q-btn round flat @click="showLoginDialog = !showLoginDialog">
          <q-icon v-if="!avatarURL" name="account_circle"/>
          <img v-if="avatarURL" v-bind:src="avatarURL" class="profile-image"/>
        </q-btn>

        <q-modal v-model="showLoginDialog" minimized :content-css="{ padding: '48px' }" ref="loginModal">
          <q-modal-layout class="modal-button-wrapper">
            <div class="q-display-1 q-mb-md">Github Login</div>

            <p>
              You can log into your github account to significantly boost your rate limit.
              If you enable the checkbox your login data is stored in your browser on your computer.<br>
              NONE of your data gets submitted to our servers, ONLY to github!
            </p>

            <q-input v-model="username" float-label="Username"/>

            <q-input v-model="password" type="password" float-label="Password"/>

            <q-toggle v-model="shouldStoreLoginData" label="Store login data in your browser?" />

            <div class="button-container">
              <q-btn @click="handleLoginData(username, password, shouldStoreLoginData)" label="Login" />
              <q-btn color="red" v-close-overlay label="Cancel" />
            </div>
          </q-modal-layout>
        </q-modal>

        <q-btn icon="more_vert" round flat>
          <q-popover ref="popover">
            <q-list link class="scroll" style="min-width: 270px">
              <q-item>
                <q-item-tile icon="code" style="padding-right: 16px"/>
                <a style="color: black" href="https://gitlab.com/nik.zantner/commitlog" target="_blank"
                   rel="noopener noreferrer">Code on Gitlab</a>
              </q-item>
              <q-item>
                <q-item-tile icon="face" style="padding-right: 16px"/>
                <a style="color: black" href="https://niklaszantner.de" target="_blank"
                   rel="noopener noreferrer">About the Author</a>
              </q-item>
              <q-item>
                <q-item-tile icon="info" style="padding-right: 16px"/>
                <q-item-main @click.native="goToLegal()" label="Imprint, Privacy and Legal"/>
              </q-item>
            </q-list>
          </q-popover>
        </q-btn>
      </q-toolbar>
    </q-layout-header>

    <q-page-container>
      <router-view/>
    </q-page-container>
  </q-layout>
</template>

<script>
import {
  QLayout, QToolbar, QToolbarTitle, QBtn, Dialog, QTooltip, QPopover, QList, QItem, QIcon, QItemTile,
  QItemMain, QLayoutHeader, QPageContainer, QModal, QInput, QToggle,
} from 'quasar';
import CommitService from './commits/CommitService';

export default {
  data() {
    return {
      totalRateLimit: undefined,
      remainingRateLimit: undefined,
      avatarURL: undefined,
      showLoginDialog: false,
      password: null,
      username: null,
      shouldStoreLoginData: null,
    };
  },
  methods: {
    goToLegal() {
      this.$router.push({ path: '/legal' });
    },
    updateRateLimits(totalRateLimit, remainingRateLimit) {
      this.totalRateLimit = totalRateLimit;
      this.remainingRateLimit = remainingRateLimit;
    },
    handleLoginData(username, password, shouldStoreLoginData) {
      CommitService.login(username, password, shouldStoreLoginData);
      this.setAvatarURL();
      this.$refs.loginModal.hide();
    },
    setAvatarURL() {
      CommitService.getUserProfile().then(user => this.avatarURL = user.avatar_url);
    },
  },
  mounted() {
    CommitService.subscribeToRateLimitUpdates(this.updateRateLimits);

    if (CommitService.isUserLoggedIn()) {
      this.setAvatarURL();
      const { username, password } = CommitService.getLoginData();
      this.username = username;
      this.password = password;

      if (this.username && this.password) {
        this.shouldStoreLoginData = true;
      }
    }
  },
  components: {
    QLayout,
    QToolbar,
    QToolbarTitle,
    QBtn,
    QTooltip,
    QPopover,
    QList,
    QItem,
    QIcon,
    QItemTile,
    QItemMain,
    QLayoutHeader,
    QPageContainer,
    QModal,
    QInput,
    QToggle,
  },
};
</script>
